/*
   This demonstrates a mistake on page 29 of the textbook
   "Advanced Graphics Programming Using OpenGL", by Tom McReynolds
   and David Blythe, Morgan Kaufmann, 2005.


   http://www.opengl-doc.com/Morgan.Kaufmann-Advanced.Graph/pg_0057.htm
*/
#include <windows.h>
#include "glut.h"


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Page 29");    /* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-3.0, 3.0, -3.0, 3.0); /* viewing volume */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of the model down the graphics pipeline. */
void model( void )
{
   glBegin(GL_LINE_LOOP);
      glVertex2f( 0.5,  0.0);
      glVertex2f( 0.0,  1.0);
      glVertex2f(-0.5,  0.0);
      glVertex2f(-0.5, -0.4);
      glVertex2f( 0.5, -0.4);
   glEnd();
}//model()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   glColor3f(0.0, 0.0, 0.0);     // Draw in black.
   glBegin(GL_LINES);            // Draw a pair of axes.
      glVertex2f(-3.0,  0.0);
      glVertex2f( 3.0,  0.0);
      glVertex2f( 0.0, -3.0);
      glVertex2f( 0.0,  3.0);
   glEnd();

   glColor3f(0.7, 0.7, 1.0);     // Draw in light blue.
   model();                      // Draw the basic model.
   glColor3f(0.0, 0.0, 1.0);     // Draw in blue.

/*
   glRotatef(45.0, 0.0, 0.0, 1.0);  // This is the code that is in the book.
   glTranslatef(1.0, 1.0, 0.0);     // There are two mistakes; the angle should be negative,
   model();                         // and the order of the transformations should be reversed.
*/

   glTranslatef(1.0, 1.0, 0.0);     // This is what matches the picture in the book..
   glRotatef(-45.0, 0.0, 0.0, 1.0);
   model();

   glFlush();

}//display()
